#ifndef JELIZA_MANAGER
#define JELIZA_MANAGER 1


/*
 * This is part of JEliza revision 5X.
 * Copyright 2008 by Tobias Schulz
 * WWW: http://jeliza.ch.to/
 *
 * JEliza is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later
 * version.
 *
 * JEliza is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU GPL
 * along with JEliza (file COPYING) ; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#include "defs.h"

using namespace std;

shared_ptr<jeliza::jeliza_manager> global_jeliza(new jeliza::jeliza_manager());

/*
 * Die << und >> Operatoren
 */
jeliza::jeliza_manager& jeliza::jeliza_manager::operator<< (std::string fra) {
    m_jel.ask(jeliza::string(fra));

    return *this;
}
jeliza::jeliza_manager& jeliza::jeliza_manager::operator<< (jeliza::strings ans) {
//    m_jel.init();
//    m_jel.learn(ans);
//    m_jel.init();

    return *this;
}

jeliza::jeliza_impl& jeliza::jeliza_manager::get() {
    return m_jel;
}

void jeliza::jeliza_manager::start () {
    m_jel.start();
}

bool database_present = true;

void jeliza::destroy () {
    if (database_present) {
        cout << "Writing data to word database, language " << jeliza::get_lang_str().ref() << endl;
        jeliza::string temp;
        jeliza::string temp2;
        for (unsigned int x = 0; x < jeliza::spo_split::get().wordtype_database->size(); x++) {
            jeliza::string str;
            (*jeliza::spo_split::get().wordtype_database)[x][2] = jeliza::string(".");
            util::join(str, ";", (*jeliza::spo_split::get().wordtype_database)[x]);
            temp += str;
            temp += "\n";
        }
        for (unsigned int x = 0; x < jeliza::spo_split::get().genuss->size(); x++) {
        	jeliza::string str((*jeliza::spo_split::get().genuss)[x]);
        	str = (*jeliza::spo_split::get().genus_index)[str.ref()] + ";" + str;
        	temp2 += str;
        	temp2 += "\n";
        }

        cout << "Writing data NOW to word database, language " << jeliza::get_lang_str().ref() << endl;

        ofstream o(("lang_" + jeliza::get_lang_str() + "/wsh/dic.wsh").ref().c_str());
        o << temp.ref() << endl;
        o.close();
        ofstream o2(("lang_" + jeliza::get_lang_str() + "/wsh/genus.wsh").ref().c_str());
        o2 << temp2.ref() << endl;
        o2.close();

//        std::exit(0);
        database_present = false;
    }
}
jeliza::jeliza_manager::~jeliza_manager () {
}

jeliza::jeliza_manager::jeliza_manager () {
}

void jeliza::jeliza_manager::make_current() {
    global_jeliza.reset(this);
}

void jeliza::jeliza_manager::destroy_current() {
}

jeliza::jeliza_manager* jeliza::jeliza_manager::get_current() {
    return &(*global_jeliza);
}


#endif

